#ifndef EETSENDER_H
#define EETSENDER_H

#include <QObject>

#include "eetcpp_global.h"
#include "eetrequest.h"
#include "eettemplate.h"
#include "eetresult.h"

class QNetworkAccessManager;
class QNetworkReply;

class EETCPPSHARED_EXPORT EetSender : public QObject
{
    Q_OBJECT
public:
    explicit EetSender(QObject *parent = 0);

    void sendRequest(EetRequest *request);
    void setupSigner(const QString &certPath, const QString &passwd);

    void setCheckSignature(bool checkSignature);
    bool checkSignature() const;

    EetResult *resut() const;

private:
    static const QString ms_nsDef;
    EetSigner *m_signer;
    QNetworkAccessManager *m_manager;
    bool m_checkSignature;
    EetResult *m_resut;

    bool verifySignature(const QByteArray &repData);

private slots:
    void replyFinished(QNetworkReply *reply);

signals:
    void certError();
    void sendError();
    void responseRecieved(EetRequest *result);
    void signInvalid();
    void serviceCertError();

public slots:
};

#endif // EETSENDER_H
